{{ Memory tester for SPI-SRAM
        Tim Moore 2008
}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ 
                                                        '2 Cog here 
  sram          : "spisram"                             '1 COG
  
  uarts         : "pcFullDuplexSerial4FC"               '1 COG for 4 serial ports

  config        : "config"                              'no COG required

VAR
  long  buffer[32]
  long  obuffer[32]
        
Pub Start | i,count,same,starttime,wtotal,rtotal
  config.Init(@pininfo,0)                               'initialize config setup

  waitcnt(clkfreq*3 + cnt)                              'delay for debugging
  
  uarts.Init
  uarts.AddPort(0,config.GetPin(CONFIG#DEBUG_RX),config.GetPin(CONFIG#DEBUG_TX),{
}   UARTS#PINNOTUSED,UARTS#PINNOTUSED,UARTS#DEFAULTTHRESHOLD, {
}   UARTS#NOMODE,UARTS#BAUD115200)                      'Add debug port
  uarts.Start                                           'Start the ports
  
  uarts.str(0,string("Memtest V1.0",13))
  
  sram.Start(config.GetPin(CONFIG#SPISRAM_D0))

  uarts.str(0,string("SRAM started",13))
  
  repeat i from 0 to 31
    obuffer[i] := i

  wtotal := 0
  rtotal := 0
  repeat
    if (count & $ff) == 0
      uarts.str(0,string("test "))
      uarts.dec(0,count)
      uarts.tx(0," ")
      uarts.dec(0,rtotal)
      uarts.tx(0," ")
      uarts.dec(0,wtotal)
      uarts.tx(0,13)

    starttime := cnt    
    sram.Write(0,@obuffer,32)
    wtotal += cnt - starttime     
    starttime := cnt    
    sram.Read(0,@buffer,32)
    rtotal += cnt - starttime     

    same := 1
    repeat i from 0 to 31
      if obuffer[i] <> buffer[i]
        same := 0
        quit
    if same == 0             
      repeat i from 0 to 31
        uarts.hex(0, obuffer[i],8)
        uarts.tx(0," ")
      uarts.tx(0,":")
      repeat i from 0 to 31
        uarts.hex(0, buffer[i],8)
        uarts.tx(0," ")
      uarts.tx(0,13)
    repeat i from 0 to 31
      obuffer[i] += 32
    count++

DAT
'pin configuration table for this project
pininfo       word CONFIG#SPISRAM_D0            'pin 0
              word CONFIG#SPISRAM_D1            'pin 1
              word CONFIG#SPISRAM_D2            'pin 2
              word CONFIG#SPISRAM_D3            'pin 3
              word CONFIG#SPISRAM_SCK           'pin 4
              word CONFIG#SPISRAM_CS            'pin 5
              word CONFIG#NOT_USED              'pin 6
              word CONFIG#NOT_USED              'pin 7
              word CONFIG#NOT_USED              'pin 8
              word CONFIG#NOT_USED              'pin 9
              word CONFIG#NOT_USED              'pin 10
              word CONFIG#NOT_USED              'pin 11
              word CONFIG#NOT_USED              'pin 12
              word CONFIG#NOT_USED              'pin 13
              word CONFIG#NOT_USED              'pin 14
              word CONFIG#NOT_USED              'pin 15
              word CONFIG#NOT_USED              'pin 16
              word CONFIG#NOT_USED              'pin 17
              word CONFIG#NOT_USED              'pin 18
              word CONFIG#NOT_USED              'pin 19
              word CONFIG#NOT_USED              'pin 20
              word CONFIG#NOT_USED              'pin 21
              word CONFIG#NOT_USED              'pin 22
              word CONFIG#NOT_USED              'pin 23
              word CONFIG#NOT_USED              'pin 24
              word CONFIG#NOT_USED              'pin 25
              word CONFIG#NOT_USED              'pin 26
              word CONFIG#NOT_USED              'pin 27
              word CONFIG#I2C_SCL1              'pin 28
              word CONFIG#I2C_SDA1              'pin 29
              word CONFIG#DEBUG_TX              'pin 30
              word CONFIG#DEBUG_RX              'pin 31